PROC (2)=canon(rk,r0);
local beta,lmbd,zk,z0,skk,s00,sk0,ww,gtilde,beta,flip,pk;

pk   = cols(rk);                        @ Useful when imposing constraints @
flip = design(seqa(pk,-1,pk));          @ Useful to flip the column order  @

zk= rk - meanc(rk)';     @ DE-MEAN the RESIDUAL MATRICES???   @
z0= r0 - meanc(r0)';

s00   = (z0'z0)./(rows(zk)-1);    @ Form moment matrices...   @
skk   = (zk'zk)./(rows(zk)-1);
sk0   = (zk'z0)./(rows(zk)-1);
/*
" s00 ";
s00;
" skk ";
skk;
" sk0 ";
sk0;
  */


           ww = chol( invpd(skk) );                     @ Make this a       @
/* " ww";
ww;  */


{lmbd,gtilde} = eigrs2( ww*sk0*invpd(s00)*sk0'*ww' );   @ symmetric eigen   @
         beta = ww'gtilde;                              @ problem...        @

lmbd = flip*lmbd;                 @ Rearrange eigenvectors & eigenvalues    @
beta = beta*flip;                 @ to run from largest to smallest... and  @
beta = beta ./ beta[1,.];         @ Normalize beta s.t. 1st element = 1     @

retp(lmbd, beta);
endp;
